/* @file "myDemoPing_AM.c"
 * This is the user code for Module myDemoPing_AM
 */

#include <stdio.h>
#include <string.h>
#include "myDemoPing_AM.h"

/* The following functions must be implemented by this module: */

/* Entrypoints for lifecycle events */
void myDemoPing_AM__INITIALIZE__received(myDemoPing_AM__context* context) {
	/* One-shot initialisation activities: */
	/* To be implemented */

}

void myDemoPing_AM__START__received(myDemoPing_AM__context* context) {
	/* To be implemented */
}

void myDemoPing_AM__STOP__received(myDemoPing_AM__context* context) {
	/* To be implemented */
}

void myDemoPing_AM__SHUTDOWN__received(myDemoPing_AM__context* context) {
	/* To be implemented */
}

/* Entrypoints for module operations */
void myDemoPing_AM__Pong__received(myDemoPing_AM__context* context) {
	ECOA__log log = { 13, "Pong received" };

	myDemoPing_AM_container__log_trace(context, log);
}

void myDemoPing_AM__TriggerPingRequest__received(
		myDemoPing_AM__context* context) {
	ECOA__return_status return_status;
	ECOA__log log;
	pingpong__T_Target_Position pingTarget = { 1, { 45, 45 }, ECOA__TRUE };
	pingpong__T_Target_Position pongTarget;

	return_status = myDemoPing_AM_container__PingPong__request_sync(context,
			&pingTarget, &pongTarget);

	if (return_status != ECOA__return_status_OK) {
		snprintf(log.data, ECOA__LOG_MAXSIZE, "Request return_status : %2d",
				return_status);
		log.current_size = strlen(log.data);
	} else {
		snprintf(log.data, ECOA__LOG_MAXSIZE,
				"Pong response : %2d %2.1f %2.1f %d",
				pongTarget.Tactical_Item_ID, pongTarget.Location.Latitude,
				pongTarget.Location.Longitude, pongTarget.Is_Valid);
		log.current_size = strlen(log.data);
	}
	myDemoPing_AM_container__log_trace(context, log);

}

void myDemoPing_AM__TriggerPingEvent__received(myDemoPing_AM__context* context) {
	myDemoPing_AM_container__Ping__send(context);
}

void myDemoPing_AM__TriggerPingCounter__received(
		myDemoPing_AM__context* context) {
	ECOA__log log;
	ECOA__log return_status_log = { 14, "Release error" };
	myDemoPing_AM_container__Counter_handle handle;
	ECOA__return_status return_status;

	return_status = myDemoPing_AM_container__Counter__get_read_access(context,
			&handle);
	if (return_status == ECOA__return_status_OK) {

		snprintf(log.data, ECOA__LOG_MAXSIZE, "Counter : %2d", *handle.data);
		log.current_size = strlen(log.data);

		myDemoPing_AM_container__log_trace(context, log);

		return_status = myDemoPing_AM_container__Counter__release_read_access(
				context, &handle);
		if (return_status != ECOA__return_status_OK) {
			myDemoPing_AM_container__log_debug(context, return_status_log);
		}
	}

}

