/* @file "myDemoPong_AM.c"
 * This is the user code for Module myDemoPong_AM
 */

#include <stdio.h>
#include <string.h>
#include "myDemoPong_AM.h"

/* The following functions must be implemented by this module: */

/* Entrypoints for lifecycle events */
void myDemoPong_AM__INITIALIZE__received(myDemoPong_AM__context* context) {
	/* One-shot initialisation activities: */
	/* To be implemented */
        context->user.counter = 0;
}


void myDemoPong_AM__START__received(myDemoPong_AM__context* context) {
	/* To be implemented */
}

void myDemoPong_AM__STOP__received(myDemoPong_AM__context* context) {
	/* To be implemented */
}

void myDemoPong_AM__SHUTDOWN__received(myDemoPong_AM__context* context) {
	/* To be implemented */
}

/* Entrypoints for module operations */
void myDemoPong_AM__PingPong__request_received(myDemoPong_AM__context* context,
		const ECOA__uint32 ID, const pingpong__T_Target_Position *Ping_Target) {
	ECOA__log log;
	pingpong__T_Target_Position Pong_Target;

	snprintf(log.data, ECOA__LOG_MAXSIZE, "Ping request : %2d %2.1f %2.1f %d",
			Ping_Target->Tactical_Item_ID, Ping_Target->Location.Latitude,
			Ping_Target->Location.Longitude, Ping_Target->Is_Valid);
	log.current_size = strlen(log.data);

	myDemoPong_AM_container__log_trace(context, log);

	Pong_Target.Tactical_Item_ID = 2;
	Pong_Target.Location.Latitude = 33.0;
	Pong_Target.Location.Longitude = 33.0;
	Pong_Target.Is_Valid = ECOA__TRUE;

	myDemoPong_AM_container__PingPong__response_send(context, ID, &Pong_Target);

}

void myDemoPong_AM__Ping__received(myDemoPong_AM__context* context) {
	ECOA__log log = { 14, "Ping received" };
	ECOA__log return_status_log = { 14, "Publish error" };
	myDemoPong_AM_container__Counter_handle handle;
	ECOA__return_status return_status;

	myDemoPong_AM_container__log_trace(context, log);
	myDemoPong_AM_container__Pong__send(context);

	return_status = myDemoPong_AM_container__Counter__get_write_access(context,
			&handle);
	if (return_status == ECOA__return_status_OK
			|| return_status == ECOA__return_status_DATA_NOT_INITIALIZED) {
		context->user.counter = context->user.counter + 1;
		*handle.data = context->user.counter;

		return_status = myDemoPong_AM_container__Counter__publish_write_access(
				context, &handle);
		if (return_status != ECOA__return_status_OK) {
			myDemoPong_AM_container__log_debug(context, return_status_log);
		}
	}

}

